// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.ArrayList;

/**
 * Verwaltet einen ungerichteten, gewichteten Graphen mittels Adjazenzmatrix
 * @author Albert Wiedemann @version 1.0
 */
public class GraphMatrix
{
    /* Feld der Knoten des Graphen*/
    private ArrayList<Knoten> knoten;
    /* 2-dim Feld der Adjazenzmatrix*/
    private ArrayList<ArrayList<Integer>> matrix;
    /* Feld der Kantensymbole des Graphen*/
    private ArrayList<KantenSymbol> kanten;

    /**
     * Baut die Datenstruktur auf
     */
    protected GraphMatrix()
    {
        /* Ergänzen laut Teilaufgabe a*/
    }

    /**
     * Einfügen eines neuen Knoten in den Graphen @param bezeichner Bezeichner des neuen Knotens, der dem Graphen hinzugefügt wird. @param x x-Koordinate für die Anzeige des Knotens @param y y-Koordinate für die Anzeige des Knotens
     */
    protected void KnotenEinfügen(String bezeichner, int x, int y)
    {
        /* Ergänzen laut Teilaufgabe b*/
    }

    /**
     * Gibt den Knoten mit dem angegebenen Bezeichner zurück. Wenn ein Knoten mit diesem Bezeichner nicht bekannt ist wird null zurückgegeben @param bezeichner Bezeichner des Knoten der gesucht wird @return Referenz auf das Knotenobjekt oder null
     */
    private Knoten KnotenGeben(String bezeichner)
    {
        for (final Knoten k : knoten) {
            if (k . BezeichnerGeben ( ) . equals ( bezeichner )) {
                return k;
            }
        }
        return null;
    }

    /**
     * Gibt die interne Nummer des Knotens Wenn ein Knoten mit diesem Bezeichner nicht bekannt ist wird -1 zurückgegeben @param bezeichner Bezeichner des Knoten der gesucht wird @return Indexnummer des Knotens im Knotenfeld; 0 <= res <= knoten.size()-1 bzw. -1
     */
    private int KnotenNummerGeben(String bezeichner)
    {
        /* Ergänzen laut Teilaufgabe c*/
        return - 1;
    }

    /**
     * Gibt die Bezeichnung eines Knotens mit der internen Knotennummer @param Indexnummer des Knotens im Knotenarray; 0<= x <= knoten.size() @return Bezeichner des Knotens
     */
    protected String KnotenBezeichnerGeben(int knotenNummer)
    {
        if (( knotenNummer < knoten . size ( ) ) && ( knotenNummer >= 0 )) {
            return knoten . get ( knotenNummer ) . BezeichnerGeben ( );
        }
        else {
            return "";
        }
    }

    /**
     * Einfügen einer Kante in den Graphen Eine Kante ist durch einen Anfangsknoten und einen Endknoten festgelegt und hat eine Gewichtung @param von Bezeichner des Anfangsknotens @param nach Bezeichner des Endknotens @param gewichtung Gewichtung der Kante als Ganzzahl
     */
    protected void KanteEinfügen(String von, String nach, int gewichtung)
    {
        /* Ergänzen laut Teilaufgabe d*/
    }

    /**
     * Gibt die Adjazenzmatrix des Graphen in der Konsole aus Nach Zeilen und Spalten formatiert Als Spaltenbreite wurde hier 4 Zeichen gewählt.
     */
    protected void Ausgeben()
    {
        /* Kopfzeile*/
        System . out . print ( " " );
        int i = 0;
        while (i < knoten . size ( )) {
            System . out . print ( ( knoten . get ( i ) . BezeichnerGeben ( ) + " " ) . substring ( 0 , 4 ) );
            i = i + 1;
        }
        System . out . println ( );
        int i = 0;
        while (i < knoten . size ( )) {
            System . out . print ( ( knoten . get ( i ) . BezeichnerGeben ( ) + " " ) . substring ( 0 , 4 ) );
            int j = 0;
            while (j < knoten . size ( )) {
                if (matrix . get ( i ) . get ( j ) != - 1) {
                    System . out . print ( ( matrix . get ( i ) . get ( j ) + " " ) . substring ( 0 , 4 ) );
                }
                else {
                    System . out . print ( " " );
                }
                j = j + 1;
            }
            System . out . println ( );
            i = i + 1;
        }
    }

    /**
     * Gibt die Anzahl der Knoten des Graphen zurück @return  Anzahl der Knoten
     */
    protected int KnotenAnzahlgeben()
    {
        return knoten . size ( );
    }

    /**
     * Gibt die Gewichtung einer Kante zurück Die Kante ist durch einen Anfangsknoten und einen Endknoten festgelegt @param von Bezeichner des Anfangsknotens @param nach Bezeichner des Endknotens @return Gewichtung der Kante
     */
    protected int KanteGewichtGeben(String von, String nach)
    {
        int vonNummer;
        int nachNummer;
        vonNummer = KnotenNummerGeben ( von );
        nachNummer = KnotenNummerGeben ( nach );
        if (( vonNummer != - 1 ) && ( nachNummer != - 1 )) {
            return matrix . get ( vonNummer ) . get ( nachNummer );
        }
        else {
            return - 1;
        }
    }

    /**
     * Löscht die Kanten und Knoten des Graphen Die Anzeige wird auch gelöscht
     */
    protected void ZurückSetzen()
    {
        for (final KantenSymbol k : kanten) {
            k . Entfernen ( );
        }
        for (final Knoten k : knoten) {
            k . SymbolGeben ( ) . Entfernen ( );
        }
        knoten . clear ( );
        kanten . clear ( );
        matrix . clear ( );
    }
}
